﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WinForm_Test;

namespace UHFAPP
{
    public partial class MainForm : Form
    {
        public delegate void DelegateOpen(bool open);
        public static event DelegateOpen eventOpen = null;

        public delegate void DelegateSwitchUI();
        public static event DelegateSwitchUI eventSwitchUI = null;

        string strOpen1 = "  Open  ";
        string strOpen2 = "  打开  ";
        string strClose1 = "  Close  ";
        string strClose2 = "  关闭  ";

        private int currentType = 0;
        private bool isOpen = false;
        public MainForm mainform = null;
        public MainForm()
        {
            InitializeComponent();
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.IsMdiContainer = true;
            mainform = this;
            toolStripComboBox1.Items.Add("中文简体");
            toolStripComboBox1.Items.Add("English");
            toolStripComboBox1.SelectedIndex = 0;
            toolStripOpen.Text = "  Open  ";
            SwitchShowUI();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
           ScanEPC();
           getComPort();
           MenuItemScanEPC.Enabled = false;
           MenuItemReadWriteTag.Enabled = false;
           configToolStripMenuItem.Enabled = false;
           uHFVersionToolStripMenuItem.Enabled = false;
           killLockToolStripMenuItem.Enabled = false;
           toolStripMenuItem1.Enabled = false;
        }
        public void enableControls()
        {
            menuStrip1.Enabled = true;
        }
        public void disableControls()
        {
            menuStrip1.Enabled = false;
        }

        //读写数据
        private void MenuItemReadWriteTag_Click(object sender, EventArgs e)
        {
             ReadWriteTag("");
        }
        //扫描EPC
        private void MenuItemScanEPC_Click(object sender, EventArgs e)
        {
            ScanEPC();
        }
        private void menuStrip1_ItemAdded(object sender, ToolStripItemEventArgs e)
        {
            if (e.Item.Text.Length == 0             //隐藏子窗体图标
              || e.Item.Text == "最小化(&N)"      //隐藏最小化按钮
              || e.Item.Text == "还原(&R)"           //隐藏还原按钮
              || e.Item.Text == "关闭(&C)")         //隐藏关闭按钮
            {
                e.Item.Visible = false;
            }
        }
        //读取EPC窗体
        private void ScanEPC()
        {
            try
            {
                toolStripStatusLabel1.Visible = true;
               Form currForm= this.ActiveMdiChild;
               if (currForm == null || currentType != 0)
                {
                    currentType = 0;
                    ReadEPCForm frm_epcScan = new ReadEPCForm(isOpen,mainform);//子窗体实例化
                    frm_epcScan.WindowState = FormWindowState.Maximized;
                    frm_epcScan.MdiParent = this;//设置当前窗体为子窗体的父窗体
                    frm_epcScan.Show();//显示窗体
                    if (currForm != null)
                        currForm.Close();
                }
            }
            catch (Exception ex)
            {

            }
        }

        //读写数据窗体
        public void ReadWriteTag(string tag)
        {
            toolStripStatusLabel1.Visible = false;
            try
            {
                Form currForm = this.ActiveMdiChild;
                if (currForm == null || currentType != 1)
                {
                    currentType = 1;
                    ReadWriteTagForm frm_readWriter = new ReadWriteTagForm(isOpen,tag);//子窗体实例化
                    frm_readWriter.WindowState = FormWindowState.Maximized;
                    frm_readWriter.MdiParent = this;//设置当前窗体为子窗体的父窗体
                    frm_readWriter.Show();//显示窗体
                    if (currForm != null)
                        currForm.Close();
                }
             
            }
            catch (Exception ex)
            {

            }
        }

        //配置界面的窗体
        private void configToolStripMenuItem_Click(object sender, EventArgs e)
        {
            toolStripStatusLabel1.Visible = false;
            try
            {
               Form currForm= this.ActiveMdiChild;
               if (currForm == null || currentType != 2)
                {
                    currentType =2;
                    ConfigForm configForm = new ConfigForm(isOpen);//子窗体实例化
                    configForm.WindowState = FormWindowState.Maximized;
                    configForm.MdiParent = this;//设置当前窗体为子窗体的父窗体
                    configForm.Show();//显示窗体
                    if (currForm != null)
                        currForm.Close();
                }
            }
            catch (Exception ex)
            {

            }  
        }


        //lock窗体
        private void Lock()
        {
            toolStripStatusLabel1.Visible = false;
            try
            {
                Form currForm = this.ActiveMdiChild;
                if (currForm == null || currentType != 3)
                {
                    currentType = 3;
                    Kill_LockForm frm_readWriter = new Kill_LockForm(isOpen);//子窗体实例化
                    frm_readWriter.WindowState = FormWindowState.Maximized;
                    frm_readWriter.MdiParent = this;//设置当前窗体为子窗体的父窗体
                    frm_readWriter.Show();//显示窗体
                    if (currForm != null)
                        currForm.Close();
                }

            }
            catch (Exception ex)
            {

            }
        }

        //UHF版本号
        private void uHFVersionToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (isOpen)
            {
                StringBuilder sb = new StringBuilder();
                frmWaitingBox f = new frmWaitingBox((obj, args) =>
                {
                    string hardwareV = UHFAPI.getInstance().GetHardwareVersion();
                    string softWareV = UHFAPI.getInstance().GetSoftwareVersion();
                    int id = UHFAPI.getInstance().GetUHFGetDeviceID();
                    if (Common.isEnglish)
                    {
                        sb.Append("Hardware version:  ");
                        sb.Append(hardwareV);
                        sb.Append("\r\nFirmware  version:  ");
                        sb.Append(softWareV);
                        sb.Append("\r\nDevice ID:  ");
                        sb.Append(id);
                    }
                    else
                    {
                        sb.Append("硬件版本:  ");
                        sb.Append(hardwareV);
                        sb.Append("\r\n固件版本:  ");
                        sb.Append(softWareV);
                        sb.Append("\r\n模块ID:  ");
                        sb.Append(id);
                    }
                });
                f.ShowDialog(this);

                MessageBoxEx.Show(this,sb.ToString());
             
            }
        }

        //打开串口
        private void toolStripButton1_Click(object sender, EventArgs e)
        {

            if (toolStripOpen.Text == strOpen1 || toolStripOpen.Text == strOpen2)
            {
                if (UHFAPI.getInstance().Open(int.Parse(cmbComPort.SelectedItem.ToString().Replace("COM", ""))))
                {
                    cmbComPort.Enabled = false;
                    if (toolStripOpen.Text == strOpen1)
                        toolStripOpen.Text = strClose1;
                    else
                        toolStripOpen.Text = strClose2;

                    isOpen = true;
                    if (eventOpen != null)
                    {
                        eventOpen(true);
                    }

                    MenuItemScanEPC.Enabled = true;
                    MenuItemReadWriteTag.Enabled = true;
                    configToolStripMenuItem.Enabled = true;
                    uHFVersionToolStripMenuItem.Enabled = true;
                    killLockToolStripMenuItem.Enabled = true;
                    toolStripMenuItem1.Enabled = true;
                }
                else
                {
                    MessageBox.Show("failed!");
                }
            }
            else {
                if (UHFAPI.getInstance().Close())
                {
                    cmbComPort.Enabled = true;
                    if (toolStripOpen.Text == strClose1)
                        toolStripOpen.Text = strOpen1;
                    else
                        toolStripOpen.Text = strOpen2;

                    isOpen = false;
                    if (eventOpen != null)
                    {
                        eventOpen(false);
                    }
                    MenuItemScanEPC.Enabled = false;
                    MenuItemReadWriteTag.Enabled = false;
                    configToolStripMenuItem.Enabled = false;
                    uHFVersionToolStripMenuItem.Enabled = false;
                    killLockToolStripMenuItem.Enabled = false;
                    toolStripMenuItem1.Enabled = false;
                }
            }

        }
        //设置串口
        private void getComPort()
        {
            string[] ArryPort = System.IO.Ports.SerialPort.GetPortNames();
            cmbComPort.Items.Clear();
            for (int i = 0; i < ArryPort.Length; i++)
            {
                cmbComPort.Items.Add(ArryPort[i]);
            }
            if (cmbComPort.Items.Count > 0)
                cmbComPort.SelectedIndex = cmbComPort.Items.Count-1;

        }

        private void MainForm_FormClosed(object sender, FormClosedEventArgs e)
        {
            UHFAPI.getInstance().Close();
        }

        private void killLockToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Lock();
        }

        private void toolStripMenuItem1_Click(object sender, EventArgs e)
        {
            if (isOpen)
            {
             
                frmWaitingBox f = new frmWaitingBox((obj, args) =>
                {
                    string Temperature = UHFAPI.getInstance().GetTemperature();
                    string temp =(Common.isEnglish?"Temperature:":"温度:") + Temperature + "℃";
                    frmWaitingBox.message = temp;
                    System.Threading.Thread.Sleep(1500);
                });
                f.ShowDialog(this);
   
          

            }
        }



      
        private void SwitchShowUI() {
            if (Common.isEnglish)
            {
                toolStripStatusLabel1.Text = "";//"                                                         "+ "                                                          tip: 1. right key can copy the selected label.     2. double-click the selected label can jump to the r/w  UI.";
                MenuItemScanEPC.Text = "ReadEPC";
                MenuItemReadWriteTag.Text = "ReadWriteTag";
                configToolStripMenuItem.Text = "Configuration";
                killLockToolStripMenuItem.Text = "Kill-Lock";
                uHFVersionToolStripMenuItem.Text = "UHF Info";
                toolStripMenuItem1.Text = "Temperature";
                toolStripLabel1.Text = "PortName";
                if (toolStripOpen.Text == strOpen2)
                {
                    toolStripOpen.Text = strOpen1;
                }
                else if (toolStripOpen.Text ==strClose2)
                {
                    toolStripOpen.Text = strClose1;
                }
              
                toolStripLabel3.Text = "语言";
        
            }
            else {
                toolStripStatusLabel1.Text = "                                                        "
                    + "                                                        提示：1.右键可以复制选中的标签    2.双击选中的标签可以跳转到读写界面";
                MenuItemScanEPC.Text = "盘点EPC";
                MenuItemReadWriteTag.Text = "读写标签";
                configToolStripMenuItem.Text = "配置";
                killLockToolStripMenuItem.Text = "锁标签";
                uHFVersionToolStripMenuItem.Text = "UHF信息";
                toolStripMenuItem1.Text = "温度";
                toolStripLabel1.Text = "串口";

                if (toolStripOpen.Text == strOpen1)
                {
                    toolStripOpen.Text = strOpen2;
                }
                else if (toolStripOpen.Text == strClose1)
                {
                    toolStripOpen.Text = strClose2;
                }
                toolStripLabel3.Text = "Language";
              
            }
         
        }

        private void toolStripComboBox1_Click(object sender, EventArgs e)
        {
         
          
        }

        private void toolStripComboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (toolStripComboBox1.SelectedIndex == 0)
            {
                Common.isEnglish = false;
            }
            else
            {
                Common.isEnglish = true;
            }
            SwitchShowUI();

            if (eventSwitchUI != null)
            {
                eventSwitchUI();
            }
        }
 
    }
}
